/* UFC-crypt: ultra fast crypt(3) implementation
   Copyright (C) 1996 Free Software Foundation, Inc.

   This library is free software, you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation, either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY, without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library, if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   @(#)crypt.m68k.S	1.3 19 Apr 1996

   Assembly code for SVR4/m68k/68klinux machines.  */

/* Contributed by schwab@issan.informatik.uni-dortmund.de (Michael Schwab) */

#define L1	%d0
#define L2	%d1
#define R1	%d2
#define R2	%d3
#define SCR1	%d4
#define SCR2	%d5

#define I	%d6
#define ITR	%d7

#define SB0	%a0
#define SB1	%a1
#define SB2	%a2
#define SB3	%a3
#define KPTR	%a4

#ifdef __STDC__
#define w(reg) w1(reg)
#define w1(reg) reg##.w
#else
#define w(reg) reg/**/.w
#endif

#define F(I,O1,O2,SBX,SBY)						\
	mov.l 	(KPTR)+, SCR1 ;		eor.l 	I, SCR1 ;		\
	mov.l	(0,SBX,w(SCR1)), SCR2 ; eor.l	SCR2, O1 ;		\
	mov.l	(4,SBX,w(SCR1)), SCR2 ;	eor.l	SCR2, O2 ;		\
	swap	SCR1 ;							\
	mov.l	(0,SBY,w(SCR1)), SCR2 ;	eor.l	SCR2, O1 ;		\
	mov.l	(4,SBY,w(SCR1)), SCR2 ;	eor.l	SCR2, O2 ;

#define G(I1,I2,O1,O2)			\
	F(I1,O1,O2,SB1,SB0) F(I2,O1,O2,SB3,SB2)

#define H G(R1,R2,L1,L2) ; G(L1,L2,R1,R2)

	.local	ary
	.comm	ary, 16, 4
	.type	ary, @object

	.text
	.globl _ufc_doit
	.type _ufc_doit, @function
_ufc_doit:

/* Preamble */

	link %a6, &0
#ifndef PIC
	movm.l	&0x3f38, -(%sp)
#else
	movm.l	&0x3f3c, -(%sp)
	lea	(%pc, _GLOBAL_OFFSET_TABLE_@GOTPC), %a5
#endif

	mov.l	24(%a6), ITR
	mov.l	20(%a6), R2
	mov.l	16(%a6), R1
	mov.l	12(%a6), L2
	mov.l	8(%a6), L1

/* Setup address registers with sb pointers */

#ifndef PIC
	mov.l	&_ufc_sb0, SB0
	mov.l	&_ufc_sb1, SB1 
	mov.l	&_ufc_sb2, SB2
	mov.l	&_ufc_sb3, SB3
#else
	mov.l	_ufc_sb0@GOT(%a5), SB0
	mov.l	_ufc_sb1@GOT(%a5), SB1
	mov.l	_ufc_sb2@GOT(%a5), SB2
	mov.l	_ufc_sb3@GOT(%a5), SB3
#endif

/* And loop... */

#ifndef PIC
	mov.l	&_ufc_keytab, KPTR
#else
	mov.l	_ufc_keytab@GOT(%a5), KPTR
#endif
.Lagain:	
	mov.l	&7, I
.Lagain1:
	H
	dbra	I, .Lagain1	
/* Permute */
	exg	R1, L1
	exg	R2, L2

	lea	-128(KPTR), KPTR

	subq.l	&1, ITR
	bne	.Lagain

/* Postamble */

	lea	ary(%pc), %a0
	mov.l	L1, (%a0)
	mov.l	L2, 4(%a0)
	mov.l	R1, 8(%a0)
	mov.l	R2, 12(%a0)
#ifndef PIC
	movm.l	(%sp)+, &0x1cfc
#else
	movm.l	(%sp)+, &0x3cfc
#endif
	unlk	%a6
	rts
.Lend:
	.size	_ufc_doit, .Lend - _ufc_doit
